#ifndef CSR_COMB_H
#define CSR_COMB_H

void csr_comb_init( int const M, int p[] )
{
	for( int i = 0; i < M; i ++ )
	{
		p[ i ] = i;
	}
}

int csr_comb( int M, int N, int p[] )
{
	for( int j = M-1; j >= 0; --j )
	{
		if( p[j] < N-(M-j) ) // Can J be incremented?
		{
			p[j] ++;
			for( int k = j+1; k < M; k ++ ) // Adjust following indexes
			{
				p[k] = p[j]+k-j;
			}
			return 1;
		}
	}
	return 0;
}

void csr_comb_print( int M, int p[] )
{
	for( int i = 0; i < M; i ++ )
	{
		printf( "%d ", p[i] );
	}
	
	printf( "\n" );
}

#endif
